//=======================================================================================
//  NANO1xxϵ USBģUART
//  Copyright Nuvoton(Shang-Hai) Technology Corp. 
//  All rights reserved. 2013 
//=======================================================================================
#include  "nano1xx.h"
#include  "nano1xx_usb_1.h" 

#define  GET_STATUS                0x00                    //USBЭ鶨11ֱ׼
#define  CLEAR_FEATURE             0x01
#define  SET_FEATURE               0x03
#define  SET_ADDRESS               0x05
#define  GET_DESCRIPTOR            0x06
#define  SET_DESCRIPTOR            0x07
#define  GET_CONFIGURATION         0x08
#define  SET_CONFIGURATION         0x09
#define  GET_INTERFACE             0x0A
#define  SET_INTERFACE             0x0B
#define  SYNC_FRAME                0x0C

#define  DESC_DEVICE               0x01                    //USBЭ鶨ļ
#define  DESC_CONFIG               0x02
#define  DESC_STRING               0x03
#define  DESC_INTERFACE            0x04
#define  DESC_ENDPOINT             0x05
#define  DESC_QUALIFIER            0x06
#define  DESC_OTHERSPEED           0x07

#define  LEN_DEVICE                18                      //USBЭ鶨豸
#define  LEN_CONFIG                9                       //USBЭ鶨
#define	 LEN_INTERFACE             9                       //USBЭ鶨Ľӿ
#define	 LEN_ENDPOINT              7                       //USBЭ鶨Ķ˵

#define  EP_BULK                   0x02                    //ĸUSBЭжĶ˵ֵ
#define  EP_INT                    0x03
#define  EP_INPUT                  0x80
#define  EP_OUTPUT                 0x00
 
#define  FLAG_SET_LINE_CODE        0x0200                  // CDC Class 
#define  DESC_HID                  0x21                    // USB HID Descriptor Type 
#define  DESC_HID_RPT              0x22                    // USB HID Descriptor Type 

#define  SEND_ENCAPSULATED_COMMAND 0x00         // CDC Class Specific Request 
#define  GET_ENCAPSULATED_RESPONSE 0x01
#define  SET_COMM_FEATURE          0x02
#define  GET_COMM_FEATURE          0x03
#define  CLEAR_COMM_FEATURE        0x04
#define  SET_LINE_CODE             0x20
#define  GET_LINE_CODE             0x21
#define  SET_CONTROL_LINE_STATE    0x22
#define  SEND_BREAK                0x23
                                   //д˵üCFGλ
#define  USB_OUT_ENDP              0x20          //˵
#define  USB_ISOCH_OUT_ENDP        0x30          //ʱ˵
#define  USB_IN_ENDP               0x40          //˵     
#define  USB_ISOCH_IN_ENDP         0x50          //ʱ˵

#define  USB_PACKET_SIZE           64            // Nanoֵ֧USBС  

#define  FLAG_EP0_DATA_IN          0x0001        //ƴ,״̬׶Դжݽ׶Щ
#define  FLAG_SET_ADDRESS          0x0002

typedef struct DRVUSBD_CTRL_STRUCT{	 
	uint32_t  ReqLen;        //ݳ, ʱ, շ
	uint8_t  *pDesc;         //ݶһʱ, ´η͵׵ַ
	uint32_t  StateFlag;     //״̬׶,Դжݽ׶Щ 
	uint8_t   ConfigState;   //жʱ,浱ǰ,Ϊ0ʱʾδ
}STR_USBD_CTRL_T ;
volatile  STR_USBD_CTRL_T   gUsbCtrl;

typedef struct DRVUSBD_CDC_STRUCT
{
	uint32_t  u32DTERate;     /* Baud rate    */
	uint8_t   u8CharFormat;   /* stop bit     */
	uint8_t   u8ParityType;   /* parity       */
	uint8_t   u8DataBits;     /* data bits    */

}STR_USBD_CDC_T;
STR_USBD_CDC_T gCdcInfo;

#define  USB_VID		           0x0416
#define  USB_PID		           0x5011
#define  BULK_IN_EP_NUM            1             //õ˵ַ
#define  BULK_OUT_EP_NUM           2
#define  INT_IN_EP_NUM             3 
const uint8_t USB_DeviceDescriptor[] =
{
	LEN_DEVICE,		/* bLength              */
	DESC_DEVICE,	/* bDescriptorType      */
	0x00, 0x02,		/* bcdUSB               */
	0x02,			/* bDeviceClass         */
	0x00,			/* bDeviceSubClass      */
	0x00,			/* bDeviceProtocol      */
	USB_PACKET_SIZE,	/* bMaxPacketSize0 */
	/* idVendor */
	USB_VID & 0x00FF,
	(USB_VID & 0xFF00) >> 8,
	/* idProduct */
	USB_PID & 0x00FF,
	(USB_PID & 0xFF00) >> 8,
	0x00, 0x03,		/* bcdDevice            */
	0x01,			/* iManufacture         */
	0x02,			/* iProduct             */
	0x00,			/* iSerialNumber        */
	0x01			/* bNumConfigurations   */
};

const uint8_t USB_ConfigDescriptor[] =
{
	LEN_CONFIG,		/* bLength              */
	DESC_CONFIG,	/* bDescriptorType      */
	0x43, 0x00,		/* wTotalLength         */  //ܳ
	0x02,			/* bNumInterfaces       */
	0x01,			/* bConfigurationValue  */
	0x00,			/* iConfiguration       */
	0xC0,			/* bmAttributes         */
	0x32,			/* MaxPower             */

	/* INTERFACE descriptor */
	LEN_INTERFACE,	/* bLength              */
	DESC_INTERFACE,	/* bDescriptorType      */
	0x00,			/* bInterfaceNumber     */
	0x00,			/* bAlternateSetting    */
	0x01,			/* bNumEndpoints        */
	0x02,			/* bInterfaceClass      */
	0x02,			/* bInterfaceSubClass   */
	0x01,			/* bInterfaceProtocol   */
	0x00,			/* iInterface           */

	/* Communication Class Specified INTERFACE descriptor */
    0x05,           /* Size of the descriptor, in bytes */
    0x24,           /* CS_INTERFACE descriptor type */
    0x00,           /* Header functional descriptor subtype */
    0x10, 0x01,     /* Communication device compliant to the communication spec. ver. 1.10 */
    
	/* Communication Class Specified INTERFACE descriptor */
    0x05,           /* Size of the descriptor, in bytes */
    0x24,           /* CS_INTERFACE descriptor type */
    0x01,           /* Call management functional descriptor */
    0x00,           /* BIT0: Whether device handle call management itself. */
                    /* BIT1: Whether device can send/receive call management information over a Data Class Interface 0 */
    0x01,           /* Interface number of data class interface optionally used for call management */

	/* Communication Class Specified INTERFACE descriptor */
    0x04,           /* Size of the descriptor, in bytes */
    0x24,           /* CS_INTERFACE descriptor type */
    0x02,           /* Abstract control management funcational descriptor subtype */
    0x00,           /* bmCapabilities       */
    
	/* Communication Class Specified INTERFACE descriptor */
    0x05,           /* bLength              */
    0x24,           /* bDescriptorType: CS_INTERFACE descriptor type */
    0x06,           /* bDescriptorSubType   */
    0x00,           /* bMasterInterface     */
    0x01,           /* bSlaveInterface0     */
    
	/* ENDPOINT descriptor */
	LEN_ENDPOINT,	                /* bLength          */
	DESC_ENDPOINT,	                /* bDescriptorType  */
	(EP_INPUT | INT_IN_EP_NUM),     /* bEndpointAddress */ //˵ַ:3,жIN
	EP_INT,		                    /* bmAttributes     */
	USB_PACKET_SIZE, 0x00,	    /* wMaxPacketSize   */
	0x01,	                        /* bInterval        */   // 1ms
			
	/* INTERFACE descriptor */
	LEN_INTERFACE,	/* bLength              */
	DESC_INTERFACE,	/* bDescriptorType      */
	0x01,			/* bInterfaceNumber     */
	0x00,			/* bAlternateSetting    */
	0x02,			/* bNumEndpoints        */
	0x0A,			/* bInterfaceClass      */
	0x00,			/* bInterfaceSubClass   */
	0x00,			/* bInterfaceProtocol   */
	0x00,			/* iInterface           */
			
	/* ENDPOINT descriptor */
	LEN_ENDPOINT,	                /* bLength          */
	DESC_ENDPOINT,	                /* bDescriptorType  */
	(EP_INPUT | BULK_IN_EP_NUM),	/* bEndpointAddress */    //˵ַ:1, Bulk in
	EP_BULK,		                /* bmAttributes     */
	USB_PACKET_SIZE, 0x00,	    /* wMaxPacketSize   */
	0x00,			                /* bInterval        */

	/* ENDPOINT descriptor */
	LEN_ENDPOINT,	                /* bLength          */
	DESC_ENDPOINT,	                /* bDescriptorType  */
	(EP_OUTPUT | BULK_OUT_EP_NUM),	/* bEndpointAddress */     //˵ַ:2, Bulk out
	EP_BULK,		                /* bmAttributes     */
	USB_PACKET_SIZE, 0x00,     /* wMaxPacketSize   */
	0x00,			                /* bInterval        */
};

#define  Maximum(a,b)              (a)>(b) ? (a) : (b)
#define  Minimum(a,b)              (a)<(b) ? (a) : (b)

////ַ֧,ЩַͿԲ,ʡռ
//const uint8_t USB_StringLang[4] =
//{
//	4,				/* bLength */
//	DESC_STRING,	/* bDescriptorType */
//	0x09, 0x04
//};
//
//const uint8_t USB_VendorStringDesc[] =
//{
//	16,
//	DESC_STRING,
//	'N', 0, 'u', 0, 'v', 0, 'o', 0, 't', 0, 'o', 0, 'n', 0
//};
//
//const uint8_t USB_ProductStringDesc[] =
//{
//	32,             /* bLength          */
//	DESC_STRING,    /* bDescriptorType  */
//	'U', 0, 'S', 0,	'B', 0,	' ', 0,	'V', 0,	'i', 0,	'r', 0,	't', 0,	'u', 0,	'a', 0,	'l', 0,	
//	' ', 0,	'C', 0,	'O', 0,	'M', 0
//};

//ָ궨壬עҪͳʼSRAMĵַһ    
#define  pSetUp                    ((uint8_t*)USBD_SRAM_BASE)     //SETUPݷSRAM 0
#define  pEnd0Data                 ((uint8_t*)(USBD_SRAM_BASE+8)) //˵0/1ݷSRAM 8

//// USB ʼ =========================================================================
void USB_Init(void)
{
  uint32_t volatile temp  = 300 ;
 
  CLK->APBCLK |= CLK_APBCLK_USBD_EN ;                      // Enable USB Clock
  GCR->IPRST_CTL2 |= GCR_IPRSTCTL2_USBD ;                  // Reset USB 
  GCR->IPRST_CTL2 &= ~GCR_IPRSTCTL2_USBD ;

  USBD->PDMA |= USB_PDMA_BYTEM_BYTE ;
  USBD->CTRL = USB_CTRL_DRVSE0 ;	
  while(temp--) ;   

  USB->BUFSEG  = 0 ;                                //Setup8ֽڴַ                           
  USB->End[0].BUFSEG = 8 ;				                   //ַ
  USB->End[0].CFG    = (USB_CFG_CSTALL | USB_IN_ENDP) ;    //˵ַ:0
  USB->End[1].BUFSEG = 8 ;				                  
  USB->End[1].CFG    = (USB_CFG_CSTALL | USB_OUT_ENDP) ;   //˵ַΪ0,ҹһ

  USB->End[2].BUFSEG = 8+64 ;				               //ַ
  USB->End[2].CFG    = (USB_IN_ENDP | BULK_IN_EP_NUM) ;    //˵ַ:1,BULK_IN_EP_NUM
  USB->End[3].BUFSEG = 8+64+64 ;                           //ַ
  USB->End[3].CFG    = (USB_OUT_ENDP | BULK_OUT_EP_NUM) ;  //˵ַ:2,BULK_OUT_EP_NUM
  USB->End[4].BUFSEG = 8+64+64+64 ;                        //ַ
  USB->End[4].CFG    = (USB_IN_ENDP | INT_IN_EP_NUM) ;     //˵ַ:3,INT_IN_EP_NUM

  USBD->CTRL = 0 ;                                         //USB Start 
  USBD->INTEN = USB_INTEN_BUSEVT | USB_INTEN_USBEVT | USB_INTEN_FLDET | USB_INTEN_WAKEUP ;
  NVIC_SetPriority (USBD_IRQn, (1<<__NVIC_PRIO_BITS) - 2);
  NVIC_EnableIRQ(USBD_IRQn);
}

void USB_CtrlOut_Ack(void)
{
  switch(gUsbCtrl.StateFlag){                                    
    case FLAG_SET_LINE_CODE :
//      if(gUsbInfo.UsbDeviceClass & USB_CLASS_CDC){
//        MultiByte_copy((void *)&gCdcInfo,(uint8_t*)(USBD_SRAM_BASE+USBD->BUFSEG0),USBD->MXPLD1);
//        USBD->CFG0 |= USB_CFG_DSQ_SYNC_DATA1 ;
//        USBD->MXPLD0 = 0 ;                                 //״̬׶׼
//      }
      break ;

    case 0 :                       //״̬׶OUT_ACKϴ޴,ᷢش
    default :
      break ;
  }
  gUsbCtrl.StateFlag = 0;
}

// ˵0Ctrl_IN,ƴ״̬׶ ==============================================
void USB_CtrlIn_Ack(void)
{
  uint32_t  Cnt ;

  switch (gUsbCtrl.StateFlag){
    case FLAG_EP0_DATA_IN :                                //ϴ
      if(gUsbCtrl.ReqLen){
        Cnt = 0 ;
        do{
          pEnd0Data[Cnt] = *gUsbCtrl.pDesc++ ;
          if(++Cnt >= USB_PACKET_SIZE) break ;
        }while(--gUsbCtrl.ReqLen) ;
        USBD->MXPLD0 = Cnt ;
      }
      else{                                                // ȫϴ
        USBD->MXPLD1 = 0 ;                                 // ״̬׶
        gUsbCtrl.StateFlag = 0 ;                           // ״̬, 
      }	
      return ;
                                                           //״̬׶ε IN_ACK 
    case FLAG_SET_ADDRESS :                                //õַ̽
        USBD->DADDR = pSetUp[2];                           //ʡȥStatusFlag
    default:
        return;    
  }
}

//// , Ϊ򻯴,ܿԲ֧ ==========================================
void USB_ClassRequest(void)
{
//  uint32_t Cnt ;
//  uint8_t *pdest, *psrc ;
//
//  gUsbCtrl.StateFlag = 0 ;
//  switch(pSetUp[1]){
//    case SET_LINE_CODE:                          // Ready to get next Ctrl out			
//      USBD->MXPLD1 = 7 ;
//      USBD->CFG1 |= USB_CFG_DSQ_SYNC_DATA1;
//      gUsbCtrl.StateFlag = FLAG_SET_LINE_CODE;
//      USBD->CFG0 |= USB_CFG_DSQ_SYNC_DATA1;
//      USBD->MXPLD0 = 7 ;                                   //״̬׶׼
//      break ;
//
//    case GET_LINE_CODE:
//      gCdcInfo.u32DTERate = 115200;	/* Baud rate : 115200 */
//      gCdcInfo.u8CharFormat = 0;		/* stop bit */
//      gCdcInfo.u8ParityType = 0;		/* parity */
//      gCdcInfo.u8DataBits = 8;		/* data bits */
//      pdest = (uint8_t*)(USBD_SRAM_BASE + USB->End[0].BUFSEG) ;
//      psrc  = (uint8_t*)&gCdcInfo ;
//      Cnt = 0 ;
//      while(Cnt++ < 7) *pdest = *psrc ; 
//      USBD->CFG0 |= USB_CFG_DSQ_SYNC_DATA1;
//      USBD->MXPLD0 = 7 ;
//      USBD->MXPLD1 = 0 ;                                   //״̬׶׼
//      break ;
//
//    case SET_CONTROL_LINE_STATE:
//      gVcomInfo.CtrlSignal = pSetUp[3];
//      gVcomInfo.CtrlSignal = (gVcomInfo.CtrlSignal << 8) | pSetUp[2];
//      USBD->CFG0 |= USB_CFG_DSQ_SYNC_DATA1;
//      USBD->MXPLD0 = 0;                                    //״̬׶׼
//      break ;
//
//    default:
      USBD->CFG0 |= USB_CFG_SSTALL;                        //֧ܲ
      USBD->CFG1 |= USB_CFG_SSTALL;
//  }
}

/// , Ϊ򻯴, ȡַ ====================================
void USB_GetDescriptor(void)
{
  uint32_t Cnt ;
  uint8_t *ptr ;

  gUsbCtrl.ReqLen = pSetUp[6] + ((uint32_t)pSetUp[7] << 8);      //䳤
  USBD->CFG0 |= USB_CFG_DSQ_SYNC_DATA1;                    //֮ǰSETUP,λToggle
  gUsbCtrl.StateFlag = 0 ;             //ȼٶ״̬׶,״̬ʲôҲ
            
  switch(pSetUp[3]){                                       //ֽھʲô
    case DESC_DEVICE:                            //豸, 18ֽ
      ptr = (uint8_t*)USB_DeviceDescriptor ;
      Cnt = 0 ;
      do{
        pEnd0Data[Cnt] = *ptr++ ;
      }while(++Cnt <= 18);                                 //豸18ֽ
      USBD->MXPLD0 = 18 ;
      break;
	 
    case DESC_CONFIG:                            //, Ȳ, 67ֽ
      gUsbCtrl.ReqLen = Minimum (gUsbCtrl.ReqLen, (USB_ConfigDescriptor[3]<<8)|USB_ConfigDescriptor[2]);
      ptr = (uint8_t*)USB_ConfigDescriptor ;
      Cnt = 0 ;
      if(gUsbCtrl.ReqLen >= USB_PACKET_SIZE){	
        do{pEnd0Data[Cnt] = *ptr++ ;}while(++Cnt <= USB_PACKET_SIZE) ;
        USBD->MXPLD0   = USB_PACKET_SIZE;
        gUsbCtrl.pDesc = (uint8_t *)USB_ConfigDescriptor + USB_PACKET_SIZE ;
        gUsbCtrl.ReqLen   -= USB_PACKET_SIZE;
        gUsbCtrl.StateFlag = FLAG_EP0_DATA_IN;
      }
      else{
        while(Cnt < gUsbCtrl.ReqLen){ pEnd0Data[Cnt] = *ptr++ ; ++Cnt;}
        USBD->MXPLD0 = Cnt;
        USBD->MXPLD1 = 0 ;                                 // ״̬׶        
      }
      break;

//    case DESC_STRING:                                      //
//      if(pSetUp[2] == 0){
//        gUsbCtrl.ReqLen = Minimum (gUsbCtrl.ReqLen, USB_StringLang[0]);
//        ptr = (uint8_t*)USB_StringLang ;
//        Cnt = 0 ;
//        do{
//          pEnd0Data[Cnt] = *ptr++ ;
//        }while(++Cnt <= gUsbCtrl.ReqLen);
//        USBD->MXPLD0 = gUsbCtrl.ReqLen;
//        break;
//      }
//      else if(pSetUp[2] == 1){
//        gUsbCtrl.ReqLen = Minimum (gUsbCtrl.ReqLen, USB_VendorStringDesc[0]);
//        if(gUsbCtrl.ReqLen >= USB_PACKET_SIZE){
//          MultiByte_copy(pCtrl, (void *)USB_VendorStringDesc, CtrlMaxPacketSize);
//          gUsbCtrl.pDesc = (uint8_t *)&USB_VendorStringDesc[USB_PACKET_SIZE];
//          USBD->MXPLD0 = CtrlMaxPacketSize;
//          gUsbCtrl.ReqLen -= CtrlMaxPacketSize;
//          gUsbCtrl.StateFlag = FLAG_EP0_DATA_IN;
//        }
//        else{
//          MultiByte_copy(pCtrl, (void *)USB_VendorStringDesc, gUsbCtrl.ReqLen);
//          USBD->MXPLD0 = gUsbCtrl.ReqLen;
//        }
//        break;
//      }
//      else if(pSetUp[2] == 2){
//        gUsbCtrl.ReqLen = Minimum (gUsbCtrl.ReqLen, USB_ProductStringDesc[0]);
//        if(gUsbCtrl.ReqLen >= USB_PACKET_SIZE){
//          MultiByte_copy(pCtrl, (void *)USB_ProductStringDesc, CtrlMaxPacketSize);
//          gUsbCtrl.pDesc = (uint8_t *)&USB_ProductStringDesc[USB_PACKET_SIZE];
//          USBD->MXPLD0 = CtrlMaxPacketSize;
//          gUsbCtrl.ReqLen -= CtrlMaxPacketSize;
//          gUsbCtrl.StateFlag = FLAG_EP0_DATA_IN;
//        }
//        else{
//          MultiByte_copy(pCtrl, (void *)USB_ProductStringDesc, gUsbCtrl.ReqLen);
//          USBD->MXPLD0 = gUsbCtrl.ReqLen;
//        }
//        break;
//      }
///	 	
//   case DESC_HID_RPT:
    default:
      USBD->CFG0 |= USB_CFG_SSTALL ;
      USBD->CFG1 |= USB_CFG_SSTALL ;
      return ;
	}
    USBD->MXPLD1 = 0;              //״̬׶׼, ЩIN, ״̬׶εOUT׼
	return ;
}

//// 11ֱ׼,ֻõļ,ɼ򻯴 =======================================
void USB_StandardRequest(void)
{
  gUsbCtrl.StateFlag = 0 ;             //ȼٶ״̬׶,״̬ʲôҲ

  switch (pSetUp[1]){                            //
    case GET_DESCRIPTOR:
      USB_GetDescriptor() ; 
      return  ;

    case SET_ADDRESS:                            //趨ַ
      gUsbCtrl.StateFlag = FLAG_SET_ADDRESS;               //ݽ׶
      USBD->CFG0 |= USB_CFG_DSQ_SYNC_DATA1 ;
      USBD->MXPLD0 = 0;                                    //״̬׶׼
      return; 
 
    case SET_CONFIGURATION:                     //趨ֵ
      gUsbCtrl.ConfigState = pSetUp[2] ;                   //ֵ
      USBD->MXPLD2 = 0;                                    //˵2 Tx0
      USBD->MXPLD3 = USB_PACKET_SIZE ;                     //˵3 Rx׼
      USBD->CFG0 |= USB_CFG_DSQ_SYNC_DATA1;
      USBD->MXPLD0 = 0;                                    //״̬׶׼
      return ; 
 
//    case CLEAR_FEATURE:
//    case SET_FEATURE:
//      if((pSetUp[0] == 2) && (USB->RAM[2] == FEATURE_ENDPOINT_HALT)){
//        uint32_t u32CfgAddr;
//        uint32_t u32Cfg;
//        uint32_t i;
//
//        u32Cfg = pSetUp[4] & 0xF;
//        for (i = 0; i < gTotalEnpointCount+2; i++) {
//          if(gUsbCtrl.EPInfo[i] == u32Cfg){
//            u32Cfg = i;
//            break;
//          }
//        }
//        u32CfgAddr = (uint32_t)(u32Cfg << 4) + (uint32_t)0x40060028; /* USBD_CFG0 */
//        u32Cfg = *((__IO uint32_t *) (u32CfgAddr));
//
//        if(pSetUp[1] == CLEAR_FEATURE)  u32Cfg &= ~USB_CFG_SSTALL;
//        else  u32Cfg |= USB_CFG_SSTALL;
//        *((__IO uint32_t *) (u32CfgAddr)) = u32Cfg;
//      }
//      else  return ; 
//				
//      USBD->CFG0 |= USB_CFG_DSQ_SYNC_DATA1;
//      USBD->MXPLD0 = 0;
//      return ; 
  
//    case GET_CONFIGURATION:
//      *ptr = gUsbCtrl.ConfigState ;                      //ͷһֽ:ֵ
//      USBD->CFG0 |= USB_CFG_DSQ_SYNC_DATA1 ;
//      USBD->MXPLD0  = 1 ;                                //׼
//      USBD->MXPLD1  = 0 ;                                //״̬׶׼
//      return ; 
 
//    case GET_STATUS : {
//      uint8_t u8Data;

//      u8Data = *(uint8_t *)(USBD_SRAM_BASE + USB->BUFSEG) ;
//      if(u8Data == 0x80){                                  //豸
//        if (USB_ConfigDescriptor[7] & 0x40) ptr[0] = 1;    // Self-Powered
//        else  ptr[0] = 0;                                  // bus-Powered
//      }
//      else if(u8Data == 0x81)  ptr[0] = 0 ;                //ӿ
//      else if (u8Data == 0x82){                            //˵
//        uint32_t u32CfgAddr;
//        uint32_t u32Cfg;
//        uint32_t i;
//
//        u32Cfg = (*(uint8_t *)(USBD_SRAM_BASE + USB->BUFSEG)+4) & 0xF;         //˵ַ
//        for(i = 0; i < 5; i++){
//          if(gUsbCtrl.EPInfo[i] == u32Cfg){				//ҵӦĶ˵ַ
//            u32Cfg = i;
//            break;
//          }
//        }
//        u32CfgAddr = (uint32_t)(u32Cfg << 4) + (uint32_t)0x40060028; //ҵö˵üĴ
//        ptr[0] = *((__IO uint32_t *) (u32CfgAddr)) & USB_CFG_SSTALL? 1: 0 ;
//      }
//      else  return; 
//   			
//      ptr[1] = 0;
//      USBD->CFG0 |= USB_CFG_DSQ_SYNC_DATA1;
//      USBD->MXPLD0 = 2;
//      USBD->MXPLD1  = 0 ;                                  //״̬׶׼
//      return ;
//    }

//    case GET_INTERFACE:
//      ptr[0] = 0;
//      USBD->CFG0 |= USB_CFG_DSQ_SYNC_DATA1;
//      USBD->MXPLD0 = 1;
//      USBD->MXPLD1  = 0 ;                                  //״̬׶׼
//      return ;
// 
//    case SET_INTERFACE:
//      USBD->CFG0 |= USB_CFG_DSQ_SYNC_DATA1;
//      USBD->MXPLD0 = 0;                                    //״̬׶׼
//      return ;

    default:
      USBD->CFG0 |= USB_CFG_SSTALL ;
      USBD->CFG1 |= USB_CFG_SSTALL ;
      return ;
  }
}

//// USB շжϴ, SETUPж,8˵¼жϣøԵĴ ==============
void USB_UsbEvent(uint32_t u32INTSTS)
{
  if(u32INTSTS & USB_INTSTS_SETUP){		   
    USBD->INTSTS = USB_INTSTS_SETUP;     
    switch(pSetUp[0] & 0x60){          //D[6,5]:0=Stardard,1=Class,2=Vendor,3=Reserved 
      case 0:                                              // 0x00, 11ֱ׼
        USB_StandardRequest();          
        break;
      case 0x20:                                           // 0x20, 
        USB_ClassRequest();
        break;
      case 0x40:                                           // 0x40, Զ
      default:                                             // ֧, ӦSTALL 		   
        USBD->CFG0 |= USB_CFG_SSTALL ;
        USBD->CFG1 |= USB_CFG_SSTALL ;
    }                      
  }
  else if(u32INTSTS & USB_INTSTS_EPEVT0){                  // Ctrl_In,˵ַ: 0 
    USB_CtrlIn_Ack();
    USBD->INTSTS = USB_INTSTS_EPEVT0;
  }
  else if(u32INTSTS & USB_INTSTS_EPEVT1){		           // Ctrl_Out, ˵ַ: 0 	  
    USBD->INTSTS = USB_INTSTS_EPEVT1;
    USB_CtrlOut_Ack();
  }
  else if(u32INTSTS & USB_INTSTS_EPEVT2){	               //Bulk_In, ˵ַ: 1 
    USBD->INTSTS = USB_INTSTS_EPEVT2;
    USB_Tx_OVER() ;
  }
  else if(u32INTSTS & USB_INTSTS_EPEVT3){	
    USBD->INTSTS = USB_INTSTS_EPEVT3;                      //Bulk_Out, ˵ַ: 2
    USB_Rx_Data();                                         //յ
    USBD->CFG0 |= USB_CFG_DSQ_SYNC_DATA1;
    USBD->MXPLD0 = 0;                                      //״̬׶׼
    USBD->MXPLD3 = USB_PACKET_SIZE ;                       //˵3 Rx׼һ

  }
  else if(u32INTSTS & USB_INTSTS_EPEVT4){
    USBD->INTSTS = USB_INTSTS_EPEVT4;                      //ж In , ˵ַ: 3

  }	
  else if(u32INTSTS & USB_INTSTS_EPEVT5){
    USBD->INTSTS = USB_INTSTS_EPEVT5;	
  }	
  else if(u32INTSTS & USB_INTSTS_EPEVT6){
    USBD->INTSTS = USB_INTSTS_EPEVT6;	
  }	
  else if(u32INTSTS & USB_INTSTS_EPEVT7){
    USBD->INTSTS = USB_INTSTS_EPEVT7;	
  }	
  else{                                         		
    USBD->INTSTS = USB_INTSTS_USB_STS;
  }
}

//== USB жϴ, ֻUSB¼ǵú, ¼ֱӴ ============================
//ĸжԴ: USBշж, ¼ж, ж, ж. 
void USBD_IRQHandler(void)
{
  uint32_t u32INTSTS = USBD->INTSTS;

  if(u32INTSTS & USB_INTSTS_USB_STS){            //USB շж
    USB_UsbEvent(u32INTSTS);
  }

  else if(u32INTSTS & USB_INTSTS_BUS_STS){       //Busж
    if (USBD->BUSSTS & USB_BUSSTS_SUSPEND){		          
      USBD->CTRL  &= ~USB_CTRL_PHY_EN ;                              //߹
    }
    else if (USBD->BUSSTS & USB_BUSSTS_RESUME){           
      USBD->CTRL  |=  USB_CTRL_PHY_EN  ;                             //߻ָ
    }
    else if (USBD->BUSSTS & USB_BUSSTS_USBRST){                      //߸λ
      USBD->CTRL |= USB_CTRL_DPPU_EN | USB_CTRL_PWRDB | USB_CTRL_PHY_EN | USB_CTRL_USB_EN ; 		
      USBD->DADDR            = 0 ;	
      gUsbCtrl.ConfigState   = 0 ;
      gUsbCtrl.StateFlag     = 0 ;
	}
    USBD->INTSTS = USB_INTSTS_BUS_STS ; 	                         //жϱ־
  }

  else if (u32INTSTS & USB_INTSTS_FLD_STS){      // ж
    USBD->INTSTS = USB_INTSTS_FLD_STS ;	
    if (USBD->BUSSTS & USB_BUSSTS_FLDET_IN){                      //USB Plug In,PHY
      USBD->CTRL |= USB_CTRL_DPPU_EN | USB_CTRL_PWRDB | USB_CTRL_PHY_EN | USB_CTRL_USB_EN ;   
    }
    else  USBD->CTRL = 0 ;                                      //USB Un-plug,Disable USB 	 
  }

  else if (u32INTSTS & USB_INTSTS_WKEUP_STS){    //Wake up ж
    USBD->INTSTS |= USB_INTSTS_WKEUP_STS;                            //־λ
  }
}
